docker_entrypoint.sh 9.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157
  1. #!/bin/bash
  2. # This Docker ENTRYPOINT script is called by `docker run archivebox ...` or `docker compose run archivebox ...`.
  3. # It takes a CMD as $* shell arguments and runs it following these setup steps:
  4. # - Set the archivebox user to use the correct PUID & PGID
  5. # 1. highest precedence is for valid PUID and PGID env vars passsed in explicitly
  6. # 2. fall back to DETECTED_PUID of files found within existing data dir
  7. # 3. fall back to DEFAULT_PUID if no data dir or its owned by root
  8. # - Create a new /data dir if necessary and set the correct ownership on it
  9. # - Create a new /browsers dir if necessary and set the correct ownership on it
  10. # - Check whether we're running inside QEMU emulation and show a warning if so.
  11. # - Check that enough free space is available on / and /data
  12. # - Drop down to archivebox user permisisons and execute passed CMD command.
  13. # Bash Environment Setup
  14. # http://redsymbol.net/articles/unofficial-bash-strict-mode/
  15. # https://www.gnu.org/software/bash/manual/html_node/The-Set-Builtin.html
  16. # set -o xtrace
  17. # set -o nounset
  18. set -o errexit
  19. set -o errtrace
  20. set -o pipefail
  21. # IFS=$'\n'
  22. # Load global invariants (set by Dockerfile during image build time, not intended to be customized by users at runtime)
  23. export DATA_DIR="${DATA_DIR:-/data}"
  24. export ARCHIVEBOX_USER="${ARCHIVEBOX_USER:-archivebox}"
  25. # Global default PUID and PGID if data dir is empty and no intended PUID+PGID is set manually by user
  26. export DEFAULT_PUID=911
  27. export DEFAULT_PGID=911
  28. # If user tires to set PUID and PGID to root values manually, catch and reject because root is not allowed
  29. if [[ "$PUID" == "0" ]]; then
  30. echo -e "\n[X] Error: Got PUID=$PUID and PGID=$PGID but ArchiveBox is not allowed to be run as root, please change or unset PUID & PGID and try again." > /dev/stderr
  31. echo -e " Hint: some NFS/SMB/FUSE/etc. filesystems force-remap/ignore all permissions," > /dev/stderr
  32. echo -e " leave PUID/PGID unset, or use values the filesystem prefers (defaults to $DEFAULT_PUID:$DEFAULT_PGID)" > /dev/stderr
  33. echo -e " https://linux.die.net/man/8/mount.cifs#:~:text=does%20not%20provide%20unix%20ownership" > /dev/stderr
  34. exit 3
  35. fi
  36. # If data directory already exists, autodetect detect owner by looking at files within
  37. export DETECTED_PUID="$(stat -c '%u' "$DATA_DIR/logs/errors.log" 2>/dev/null || echo "$DEFAULT_PUID")"
  38. export DETECTED_PGID="$(stat -c '%g' "$DATA_DIR/logs/errors.log" 2>/dev/null || echo "$DEFAULT_PGID")"
  39. # If data directory exists but is owned by root, use defaults instead of root because root is not allowed
  40. [[ "$DETECTED_PUID" == "0" ]] && export DETECTED_PUID="$DEFAULT_PUID"
  41. # Set archivebox user and group ids to desired PUID/PGID
  42. usermod -o -u "${PUID:-$DETECTED_PUID}" "$ARCHIVEBOX_USER" > /dev/null 2>&1
  43. groupmod -o -g "${PGID:-$DETECTED_PGID}" "$ARCHIVEBOX_USER" > /dev/null 2>&1
  44. # re-set PUID and PGID to values reported by system instead of values we tried to set,
  45. # in case wonky filesystems or Docker setups try to play UID/GID remapping tricks on us
  46. export PUID="$(id -u archivebox)"
  47. export PGID="$(id -g archivebox)"
  48. # Check the permissions of the data dir (or create if it doesn't exist)
  49. if [[ -d "$DATA_DIR/archive" ]]; then
  50. if touch "$DATA_DIR/archive/.permissions_test_safe_to_delete" 2>/dev/null; then
  51. # It's fine, we are able to write to the data directory (as root inside the container)
  52. rm -f "$DATA_DIR/archive/.permissions_test_safe_to_delete"
  53. # echo "[√] Permissions are correct"
  54. else
  55. # the only time this fails is if the host filesystem doesn't allow us to write as root (e.g. some NFS mapall/maproot problems, connection issues, drive dissapeared, etc.)
  56. echo -e "\n[X] Error: archivebox user (PUID=$PUID) is not able to write to your ./data dir (currently owned by $(stat -c '%u' "$DATA_DIR"):$(stat -c '%g' "$DATA_DIR")." >&2
  57. echo -e " Change ./data to be owned by PUID=$PUID PGID=$PGID on the host and retry:" > /dev/stderr
  58. echo -e " \$ chown -R $PUID:$PGID ./data\n" > /dev/stderr
  59. echo -e " Configure the PUID & PGID environment variables to change the desired owner:" > /dev/stderr
  60. echo -e " https://docs.linuxserver.io/general/understanding-puid-and-pgid\n" > /dev/stderr
  61. echo -e " Hint: some NFS/SMB/FUSE/etc. filesystems force-remap/ignore all permissions," > /dev/stderr
  62. echo -e " leave PUID/PGID unset, or use values the filesystem prefers (defaults to $DEFAULT_PUID:$DEFAULT_PGID)" > /dev/stderr
  63. echo -e " https://linux.die.net/man/8/mount.cifs#:~:text=does%20not%20provide%20unix%20ownership" > /dev/stderr
  64. exit 3
  65. fi
  66. else
  67. # create data directory
  68. mkdir -p "$DATA_DIR/logs"
  69. fi
  70. # force set the ownership of the data dir contents to the archivebox user and group
  71. # this is needed because Docker Desktop often does not map user permissions from the host properly
  72. chown $PUID:$PGID "$DATA_DIR"
  73. chown $PUID:$PGID "$DATA_DIR"/*
  74. # also chown BROWSERS_DIR because otherwise 'archivebox setup' wont be able to install chrome at runtime
  75. export PLAYWRIGHT_BROWSERS_PATH="${PLAYWRIGHT_BROWSERS_PATH:-/browsers}"
  76. mkdir -p "$PLAYWRIGHT_BROWSERS_PATH/permissions_test_safe_to_delete"
  77. chown $PUID:$PGID "$PLAYWRIGHT_BROWSERS_PATH"
  78. chown $PUID:$PGID "$PLAYWRIGHT_BROWSERS_PATH"/*
  79. rm -Rf "$PLAYWRIGHT_BROWSERS_PATH/permissions_test_safe_to_delete"
  80. # (this check is written in blood in 2023, QEMU silently breaks things in ways that are not obvious)
  81. export IN_QEMU="$(pmap 1 | grep qemu >/dev/null && echo 'True' || echo 'False')"
  82. if [[ "$IN_QEMU" == "True" ]]; then
  83. echo -e "\n[!] Warning: Running $(uname -m) docker image using QEMU emulation, some things will break!" > /dev/stderr
  84. echo -e " chromium (screenshot, pdf, dom), singlefile, and any dependencies that rely on inotify will not run in QEMU." > /dev/stderr
  85. echo -e " See here for more info: https://github.com/microsoft/playwright/issues/17395#issuecomment-1250830493\n" > /dev/stderr
  86. fi
  87. # check disk space free on / and /data, warn on <500Mb free, error on <100Mb free
  88. export ROOT_USAGE="$(df --output=pcent,avail / | tail -n 1 | xargs)"
  89. export ROOT_USED_PCT="${ROOT_USAGE%%%*}"
  90. export ROOT_AVAIL_KB="$(echo "$ROOT_USAGE" | awk '{print $2}')"
  91. if [[ "$ROOT_AVAIL_KB" -lt 100000 ]]; then
  92. echo -e "\n[!] Warning: Docker root filesystem is completely out of space! (${ROOT_USED_PCT}% used on /)" > /dev/stderr
  93. echo -e " you need to free up at least 100Mb in your Docker VM to continue:" > /dev/stderr
  94. echo -e " \$ docker system prune\n" > /dev/stderr
  95. df -kh / > /dev/stderr
  96. exit 3
  97. elif [[ "$ROOT_USED_PCT" -ge 99 ]] || [[ "$ROOT_AVAIL_KB" -lt 500000 ]]; then
  98. echo -e "\n[!] Warning: Docker root filesystem is running out of space! (${ROOT_USED_PCT}% used on /)" > /dev/stderr
  99. echo -e " you may need to free up space in your Docker VM soon:" > /dev/stderr
  100. echo -e " \$ docker system prune\n" > /dev/stderr
  101. df -kh / > /dev/stderr
  102. fi
  103. export DATA_USAGE="$(df --output=pcent,avail /data | tail -n 1 | xargs)"
  104. export DATA_USED_PCT="${DATA_USAGE%%%*}"
  105. export DATA_AVAIL_KB="$(echo "$DATA_USAGE" | awk '{print $2}')"
  106. if [[ "$DATA_AVAIL_KB" -lt 100000 ]]; then
  107. echo -e "\n[!] Warning: Docker data volume is completely out of space! (${DATA_USED_PCT}% used on /data)" > /dev/stderr
  108. echo -e " you need to free up at least 100Mb on the drive holding your data directory" > /dev/stderr
  109. echo -e " \$ ncdu -x data\n" > /dev/stderr
  110. df -kh /data > /dev/stderr
  111. sleep 5
  112. elif [[ "$DATA_USED_PCT" -ge 99 ]] || [[ "$ROOT_AVAIL_KB" -lt 500000 ]]; then
  113. echo -e "\n[!] Warning: Docker data volume is running out of space! (${DATA_USED_PCT}% used on /data)" > /dev/stderr
  114. echo -e " you may need to free up space on the drive holding your data directory soon" > /dev/stderr
  115. echo -e " \$ ncdu -x data\n" > /dev/stderr
  116. df -kh /data > /dev/stderr
  117. fi
  118. export ARCHIVEBOX_BIN_PATH="$(which archivebox)"
  119. # Drop permissions to run commands as the archivebox user
  120. if [[ "$1" == /* || "$1" == "bash" || "$1" == "sh" || "$1" == "echo" || "$1" == "cat" || "$1" == "whoami" || "$1" == "archivebox" ]]; then
  121. # handle "docker run archivebox /bin/somecommand --with=some args" by passing args directly to bash -c
  122. # e.g. "docker run archivebox archivebox init:
  123. # "docker run archivebox /venv/bin/ipython3"
  124. # "docker run archivebox /bin/bash -c '...'"
  125. # "docker run archivebox cat /VERSION.txt"
  126. exec gosu "$PUID" /bin/bash -c "exec $(printf ' %q' "$@")"
  127. # printf requotes shell parameters properly https://stackoverflow.com/a/39463371/2156113
  128. # gosu spawns an ephemeral bash process owned by archivebox user (bash wrapper is needed to load env vars, PATH, and setup terminal TTY)
  129. # outermost exec hands over current process ID to inner bash process, inner exec hands over inner bash PID to user's command
  130. else
  131. # handle "docker run archivebox add some subcommand --with=args abc" by calling archivebox to run as args as CLI subcommand
  132. # e.g. "docker run archivebox help"
  133. # "docker run archivebox add --depth=1 https://example.com"
  134. # "docker run archivebox manage createsupseruser"
  135. # "docker run archivebox server 0.0.0.0:8000"
  136. exec gosu "$PUID" "$ARCHIVEBOX_BIN_PATH" "$@"
  137. fi